{$I DacDemo.inc}

unit StoredProc;

interface

uses
{$IFDEF MSWINDOWS}
  Windows, Messages,
{$ENDIF}
{$IFNDEF KYLIX}
  SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  DBCtrls, ExtCtrls, Grids, DBGrids, StdCtrls, ToolWin, ComCtrls, Buttons,
  OdacVcl,
{$ELSE}
  SysUtils, Types, Classes, QGraphics, QControls, QForms, QDialogs, QStdCtrls,
  QDBCtrls, QComCtrls, QExtCtrls, QGrids, QDBGrids, QButtons, OdacClx,
{$ENDIF}
{$IFDEF FPC}
  LResources,
{$ENDIF}
  DB, {$IFNDEF FPC}MemDS{$ELSE}MemDataSet{$ENDIF},
  DBAccess, Ora, OraScript, OdacDemoFrame, OdacDemoForm, DAScript;

type
  TStoredProcFrame = class(TOdacDemoFrame)
    DBGrid: TDBGrid;
    DataSource: TDataSource;
    ToolBar: TPanel;
    OraStoredProc: TOraStoredProc;
    Panel1: TPanel;
    btOpen: TSpeedButton;
    btClose: TSpeedButton;
    btPrepare: TSpeedButton;
    btUnPrepare: TSpeedButton;
    btExecute: TSpeedButton;
    btPrepareSQL: TSpeedButton;
    Panel2: TPanel;
    DBNavigator: TDBNavigator;
    Panel3: TPanel;
    edStoredProcName: TEdit;
    Label1: TLabel;
    procedure btOpenClick(Sender: TObject);
    procedure btCloseClick(Sender: TObject);
    procedure btPrepareClick(Sender: TObject);
    procedure btUnPrepareClick(Sender: TObject);
    procedure btExecuteClick(Sender: TObject);
    procedure btPrepareSQLClick(Sender: TObject);
  private
    { Private declarations }
    procedure ShowState;
  public
    procedure Initialize; override;
    procedure SetDebug(Value: boolean); override;
  end;

implementation

{$IFNDEF FPC}
{$IFDEF CLR}
{$R *.nfm}
{$ELSE}
{$R *.dfm}
{$ENDIF}
{$ENDIF}

procedure TStoredProcFrame.ShowState;
var
  St: string;

  procedure AddSt(S:string);
  begin
    if St <> '' then
      St := St + ', ';
    St := St + S;
  end;

begin
  St := '';

  if OraStoredProc.Prepared then begin
    AddSt('Prepared');

    if OraStoredProc.IsQuery then
      AddSt('IsQuery');

    if OraStoredProc.IsPLSQL then
      AddSt('IsPLSQL');
  end;

  if OraStoredProc.Active then
    AddSt('Active')
  else
    AddSt('Inactive');

  OdacForm.StatusBar.Panels[1].Text := St;
end;

procedure TStoredProcFrame.btOpenClick(Sender: TObject);
begin
  OraStoredProc.StoredProcName := edStoredProcName.Text;
  try
    OraStoredProc.Open;
  finally
    ShowState;
  end;
end;

procedure TStoredProcFrame.btCloseClick(Sender: TObject);
begin
  OraStoredProc.Close;
  ShowState;
end;

procedure TStoredProcFrame.btPrepareClick(Sender: TObject);
begin
  OraStoredProc.StoredProcName := edStoredProcName.Text;
  try
    OraStoredProc.Prepare;
  finally
    ShowState;
  end;
end;

procedure TStoredProcFrame.btUnPrepareClick(Sender: TObject);
begin
  OraStoredProc.UnPrepare;
  ShowState;
end;

procedure TStoredProcFrame.btExecuteClick(Sender: TObject);
begin
  OraStoredProc.StoredProcName := edStoredProcName.Text;
  try
    OraStoredProc.Execute;
  finally
    ShowState;
  end;
end;

procedure TStoredProcFrame.Initialize;
begin
  inherited;

  OraStoredProc.Connection := Connection;

  edStoredProcName.Text := OraStoredProc.StoredProcName;
  ShowState;
end;

procedure TStoredProcFrame.btPrepareSQLClick(Sender: TObject);
begin
  OraStoredProc.StoredProcName := edStoredProcName.Text;
  OraStoredProc.PrepareSQL;
  ShowState;
end;

procedure TStoredProcFrame.SetDebug(Value: boolean);
begin
  OraStoredProc.Debug := Value;
end;

initialization
{$IFDEF FPC}
{$I StoredProc.lrs}
{$ENDIF}

end.
